(* config/start.sml *)

functor StartFn(structure SysDep : SYSDEP) : START =
  struct
    fun sayErr msg = TextIO.output(TextIO.stdErr, msg)
    fun start main (arg0,argv) =
      (SysDep.handleInterrupt(main, argv); OS.Process.success)
      handle SysDep.Interrupt => (sayErr "Interrupt\n"; OS.Process.failure)
	   | exn => (sayErr "Error: "; sayErr(General.exnMessage exn);
		     sayErr "\n"; OS.Process.failure)
  end (* functor StartFn *)

