(* util/old-str-dict.sml *)

structure OldStrDict : STR_DICT =
  struct

    structure Key =
      struct
	type ord_key = string
	val compare = String.compare
      end

    datatype 'a dict	= EMPTY
			| INSERT of string * 'a * 'a dict
			| PLUS of 'a dict * 'a dict

    val empty = EMPTY
    fun insert(dict, key, attr) = INSERT(key, attr, dict)
    fun plus(bot, top) = PLUS(bot, top)

    fun find'(dict, key) =
      let fun look(EMPTY) = NONE
	    | look(INSERT(key',attr,dict)) =
		if key=key' then SOME(key',attr) else look dict
	    | look(PLUS(bot,top)) =
		case look top
		  of NONE => look bot
		   | (found as SOME _) => found
      in
	look dict
      end

    fun find(dict, key) =
      let fun look(EMPTY) = NONE
	    | look(INSERT(key',attr,dict)) =
		if key=key' then SOME attr else look dict
	    | look(PLUS(bot,top)) =
		case look top
		  of NONE => look bot
		   | (found as SOME _) => found
      in
	look dict
      end

    fun fold(f, init, dict) =
      let fun iter(EMPTY, state) = state
	    | iter(INSERT(key,attr,dict), state) = iter(dict, f(key,attr,state))
	    | iter(PLUS(bot,top), state) = iter(bot, iter(top, state))
      in
	iter(dict, init)
      end

  end (* structure OldStrDict *)
